<template>
    <div class="container">
        <v-select dense hide-details :label="label" v-model="sel" :items="value.options" @change='emitInput'>
        </v-select>
    </div>
</template>

<script lang="ts">
import Vue from 'vue'
import { SelectionData } from '@/ItemData';

// Note: typescript really does not like Vue.extend() and computed properties; <any, ...> will make 
//       these bogus errors to go away.
export default Vue.extend<any, any, any, any>({
    props: {
        value: { 
            // type: SelectionData,  // SelectionData { sel: "Option1", options: [ "Option1", "Option2" ]}
            required: true  
        },
        label: {
            type: String,
            required: true
        },        
    },

    data() {
        return {
            currentSelection: ""
        }
    },

    computed: {
        sel: {
            get(): string { 
                const v: SelectionData = this.value as SelectionData;
                return v.sel; 
            },
            set(s): void { 
                this.currentSelection = s;
            }
        }
    },

    methods: {
        emitInput(): void {
            const newVal = new SelectionData;
            newVal.sel = this.currentSelection;
            newVal.options = this.value.options;
            this.$emit("input",  newVal);
        }
    }
});
</script>

<style scoped>
.container {
    margin: 0px;
    padding: 0px;
}
</style>
